unit MaskEdit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Datasnap.DBClient,
  Vcl.ExtCtrls, Vcl.DBCtrls, Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls, Vcl.Mask;

type
  TFMaskEdit = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    CDS: TClientDataSet;
    ShowLongDateCheckBox: TCheckBox;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    MaskEdit3: TMaskEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure DBGrid1CellClick(Column: TColumn);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MaskEdit1DblClick(Sender: TObject);
    procedure MaskEdit2DblClick(Sender: TObject);
    procedure MaskEdit3DblClick(Sender: TObject);
    procedure ShowLongDateCheckBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FMaskEdit: TFMaskEdit;

implementation

{$R *.dfm}
//////////////////////////// Example moving text////////////////////////////////
procedure TFMaskEdit.DBGrid1ColEnter(Sender: TObject);
begin
  // Starts the field value whre you cliked on immediately
  MaskEdit2.EditText := cds.FieldByName('Aint').Asstring;
end;

procedure TFMaskEdit.DBGrid1CellClick(Column: TColumn);
var s : string;
    AField : TField;
begin
 // Starts the column field value
 // if you do not use them together you will mis the first instance of Cell Click
 AField := column.field ; // Fill the field
 S:= AField.AsString;     // Fil the Var

 MaskEdit2.EditText := S; // Set into Maskedit
 // it must be MaskEdit2.EditText, not MaskEdit2.EditMask!

end;
//////////////////////////// END Example moving text////////////////////////////


procedure TFMaskEdit.FormCreate(Sender: TObject);
begin

  // DefaultFormatSettings.ShortDateFormat in Lazarus
  // Use the ShortDateFormat settings only
  // ShowMessage('ddddd = '+ formatdatetime('ddddd', now));

  // Format example
  // ShowMessage('d/m/yyyy = '+ formatdatetime('d/m/yyyy', now));

  // FormatSettings.DateSeparator := '/';
  // do not use FormatSettings it overules and causes errors

    With CDS do
    begin
      FieldDefs.Clear;

      FieldDefs.Add('ADate', ftDate);
      FieldDefs.Add('AStr',  ftString, 50);
      FieldDefs.Add('AInt',  ftLargeint);
      CreateDataSet;
      //add some data
      Open;

      Append;
      FieldByName('ADate').AsString := '12-09-2003';
      Post;

      Append;
      FieldByName('AInt').AsInteger := 1;
      Post;

      Append;
      FieldByName('ADate').AsString := '12-12-2090';
      FieldByName('AInt').AsInteger := 30;
      Post;
      DBGrid1.Columns[0].Width := 150;  // this sets the date colum width
                           //which is otherwise to small for the longdate
   end ;

end;

//////////////////////////// adding to dataset /////////////////////////////////

procedure TFMaskEdit.MaskEdit1DblClick(Sender: TObject);
begin  // Must be doubleclick otherwise it will be triggerd to early
  // set the value in the database and show it in the grid
   With CDS do
    begin
      Append;
      FieldByName('ADate').AsDateTime := StrToDate(MaskEdit1.EditText);
      Post;
    end;
end;

procedure TFMaskEdit.MaskEdit2DblClick(Sender: TObject);
begin
  // set the value in the database and show it in the grid
   With CDS do
    begin
      Append;
      FieldByName('AInt').AsInteger := StrToInt(MaskEdit2.EditText);
      Post;
    end;

end;

procedure TFMaskEdit.MaskEdit3DblClick(Sender: TObject);
begin
  // set the value in the database and show it in the grid
   With CDS do
    begin
      Append;
      FieldByName('AStr').AsString := (MaskEdit3.EditText);
      Post;
    end;
end;

////////////////////////////  END adding to dataset ////////////////////////////

procedure TFMaskEdit.ShowLongDateCheckBoxChange(Sender: TObject);
var
  DateField: TDateTimeField;
  myDate   : TDateTime;
begin
  DateField := cds.FieldByName('ADate') as TDateTimeField;
  if ShowLongDateCheckBox.Checked then
    DateField.DisplayFormat := ('dddd/d/ of mmmm yyyy')
  else
    DateField.DisplayFormat := '';
end;

end.
